
function $parcel$defineInteropFlag(a) {
  Object.defineProperty(a, '__esModule', {value: true, configurable: true});
}

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}

      var $parcel$global =
        typeof globalThis !== 'undefined'
          ? globalThis
          : typeof self !== 'undefined'
          ? self
          : typeof window !== 'undefined'
          ? window
          : typeof global !== 'undefined'
          ? global
          : {};
  var parcelRequire = $parcel$global["parcelRequire6d18"];
var parcelRegister = parcelRequire.register;
parcelRegister("6KLAJ", function(module, exports) {

$parcel$defineInteropFlag(module.exports);

$parcel$export(module.exports, "Sink", () => $4eabf4a48e601aa8$export$e287445474a1d9bf);
$parcel$export(module.exports, "FileHandle", () => $4eabf4a48e601aa8$export$8bdd21c705ef8d22);
$parcel$export(module.exports, "FolderHandle", () => $4eabf4a48e601aa8$export$61db58e71d795906);
$parcel$export(module.exports, "default", () => $4eabf4a48e601aa8$export$2e2bcd8739ae039);

var $gHoWX = parcelRequire("gHoWX");

var $kfdAE = parcelRequire("kfdAE");
const { File: $4eabf4a48e601aa8$var$File, Blob: $4eabf4a48e601aa8$var$Blob, DOMException: $4eabf4a48e601aa8$var$DOMException } = (0, $kfdAE.default);
const { INVALID: $4eabf4a48e601aa8$var$INVALID, GONE: $4eabf4a48e601aa8$var$GONE, MISMATCH: $4eabf4a48e601aa8$var$MISMATCH, MOD_ERR: $4eabf4a48e601aa8$var$MOD_ERR, SYNTAX: $4eabf4a48e601aa8$var$SYNTAX, SECURITY: $4eabf4a48e601aa8$var$SECURITY, DISALLOWED: $4eabf4a48e601aa8$var$DISALLOWED } = (0, $gHoWX.errors);
class $4eabf4a48e601aa8$export$e287445474a1d9bf {
    /**
   * @param {FileHandle} fileHandle
   * @param {File} file
   */ constructor(fileHandle, file){
        this.fileHandle = fileHandle;
        this.file = file;
        this.size = file.size;
        this.position = 0;
    }
    write(chunk) {
        let file = this.file;
        if (typeof chunk === "object") {
            if (chunk.type === "write") {
                if (Number.isInteger(chunk.position) && chunk.position >= 0) {
                    this.position = chunk.position;
                    if (this.size < chunk.position) this.file = new $4eabf4a48e601aa8$var$File([
                        this.file,
                        new ArrayBuffer(chunk.position - this.size)
                    ], this.file.name, this.file);
                }
                if (!("data" in chunk)) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$SYNTAX("write requires a data argument"));
                chunk = chunk.data;
            } else if (chunk.type === "seek") {
                if (Number.isInteger(chunk.position) && chunk.position >= 0) {
                    if (this.size < chunk.position) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$INVALID);
                    this.position = chunk.position;
                    return;
                } else throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$SYNTAX("seek requires a position argument"));
            } else if (chunk.type === "truncate") {
                if (Number.isInteger(chunk.size) && chunk.size >= 0) {
                    file = chunk.size < this.size ? new $4eabf4a48e601aa8$var$File([
                        file.slice(0, chunk.size)
                    ], file.name, file) : new $4eabf4a48e601aa8$var$File([
                        file,
                        new Uint8Array(chunk.size - this.size)
                    ], file.name);
                    this.size = file.size;
                    if (this.position > file.size) this.position = file.size;
                    this.file = file;
                    return;
                } else throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$SYNTAX("truncate requires a size argument"));
            }
        }
        chunk = new $4eabf4a48e601aa8$var$Blob([
            chunk
        ]);
        let blob = this.file;
        // Calc the head and tail fragments
        const head = blob.slice(0, this.position);
        const tail = blob.slice(this.position + chunk.size);
        // Calc the padding
        let padding = this.position - head.size;
        if (padding < 0) padding = 0;
        blob = new $4eabf4a48e601aa8$var$File([
            head,
            new Uint8Array(padding),
            chunk,
            tail
        ], blob.name);
        this.size = blob.size;
        this.position += chunk.size;
        this.file = blob;
    }
    close() {
        if (this.fileHandle._deleted) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$GONE);
        this.fileHandle._file = this.file;
        this.file = this.position = this.size = null;
        if (this.fileHandle.onclose) this.fileHandle.onclose(this.fileHandle);
    }
}
class $4eabf4a48e601aa8$export$8bdd21c705ef8d22 {
    constructor(name = "", file = new $4eabf4a48e601aa8$var$File([], name), writable = true){
        this._file = file;
        this.name = name;
        this.kind = "file";
        this._deleted = false;
        this.writable = writable;
        this.readable = true;
    }
    async getFile() {
        if (this._deleted) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$GONE);
        return this._file;
    }
    async createWritable(opts) {
        if (!this.writable) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$DISALLOWED);
        if (this._deleted) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$GONE);
        const file = opts.keepExistingData ? await this.getFile() : new $4eabf4a48e601aa8$var$File([], this.name);
        return new $4eabf4a48e601aa8$export$e287445474a1d9bf(this, file);
    }
    async isSameEntry(other) {
        return this === other;
    }
    async _destroy() {
        this._deleted = true;
        this._file = null;
    }
}
class $4eabf4a48e601aa8$export$61db58e71d795906 {
    /** @param {string} name */ constructor(name, writable = true){
        this.name = name;
        this.kind = "directory";
        this._deleted = false;
        /** @type {Object.<string, (FolderHandle|FileHandle)>} */ this._entries = {};
        this.writable = writable;
        this.readable = true;
    }
    /** @returns {AsyncGenerator<[string, FileHandle | FolderHandle]>} */ async *entries() {
        if (this._deleted) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$GONE);
        yield* Object.entries(this._entries);
    }
    async isSameEntry(other) {
        return this === other;
    }
    /**
   * @param {string} name
   * @param {{ create: boolean; }} opts
   */ async getDirectoryHandle(name, opts) {
        if (this._deleted) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$GONE);
        const entry = this._entries[name];
        if (entry) {
            if (entry instanceof $4eabf4a48e601aa8$export$8bdd21c705ef8d22) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$MISMATCH);
            else return entry;
        } else {
            if (opts.create) return this._entries[name] = new $4eabf4a48e601aa8$export$61db58e71d795906(name);
            else throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$GONE);
        }
    }
    /**
   * @param {string} name
   * @param {{ create: boolean; }} opts
   */ async getFileHandle(name, opts) {
        const entry = this._entries[name];
        const isFile = entry instanceof $4eabf4a48e601aa8$export$8bdd21c705ef8d22;
        if (entry && isFile) return entry;
        if (entry && !isFile) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$MISMATCH);
        if (!entry && !opts.create) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$GONE);
        if (!entry && opts.create) return this._entries[name] = new $4eabf4a48e601aa8$export$8bdd21c705ef8d22(name);
    }
    async removeEntry(name, opts) {
        const entry = this._entries[name];
        if (!entry) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$GONE);
        await entry._destroy(opts.recursive);
        delete this._entries[name];
    }
    async _destroy(recursive) {
        for (let x of Object.values(this._entries)){
            if (!recursive) throw new $4eabf4a48e601aa8$var$DOMException(...$4eabf4a48e601aa8$var$MOD_ERR);
            await x._destroy(recursive);
        }
        this._entries = {};
        this._deleted = true;
    }
}
const $4eabf4a48e601aa8$var$fs = new $4eabf4a48e601aa8$export$61db58e71d795906("");
var $4eabf4a48e601aa8$export$2e2bcd8739ae039 = ()=>$4eabf4a48e601aa8$var$fs;

});


//# sourceMappingURL=memory.c7fc522d.js.map
